//*****************************************************************************
//*
//*
//*		ShutDownUtilityDlg.cpp : Implementierungsdatei
//*
//*
//*****************************************************************************
//
//	(C) Copyright Anton Zechner 2007
//
#include "StdAfx.h"
#include "ShutDownUtility.h"
#include "ShutDownUtilityDlg.h"
#include "TaskbarTools.h"


#ifdef		_DEBUG
#define new	 DEBUG_NEW
#undef		 THIS_FILE
static char	 THIS_FILE[] = __FILE__;
#endif

#ifndef		EWX_FORCEIFHUNG
#define		EWX_FORCEIFHUNG      0x00000010
#endif

#define 	ID_CHECKTIME	0x3491

BEGIN_MESSAGE_MAP(CShutDownUtilityDlg, CDialog)
	//{{AFX_MSG_MAP(CShutDownUtilityDlg)
	ON_WM_TIMER()
	ON_WM_PAINT()
	ON_WM_SHOWWINDOW()
	ON_WM_QUERYDRAGICON()
	ON_MESSAGE(TB_NOTIFYICON, OnIconProc)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


//*****************************************************************************
//*
//*		Konstruktor
//*
//*****************************************************************************
CShutDownUtilityDlg::CShutDownUtilityDlg(CWnd *pParent)
	: CDialog(CShutDownUtilityDlg::IDD,pParent)
{
	//{{AFX_DATA_INIT(CShutDownUtilityDlg)
	m_sTime = _T("");
	//}}AFX_DATA_INIT
	m_hIcon		= AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_bHide		= FALSE;
	m_bAutoStart= FALSE;

}


//*****************************************************************************
//*
//*		DoDataExchange
//*
//*****************************************************************************
void CShutDownUtilityDlg::DoDataExchange(CDataExchange *pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CShutDownUtilityDlg)
	DDX_Text(pDX, IDC_EDIT1, m_sTime);
	//}}AFX_DATA_MAP
}


//*****************************************************************************
//*
//*		OnInitDialog
//*
//*****************************************************************************
BOOL CShutDownUtilityDlg::OnInitDialog()
{
CRegKeys	sKey;


	if(m_sAutoTime.IsEmpty())
		{
		sKey.Open(HKEY_CURRENT_USER,"Software\\AZ\\ShutDownUtility");
		sKey.Get(m_sTime,"Time");
		}
	else{
		m_sTime = m_sAutoTime;
		}


	if(m_sTime=="")m_sTime="07:00";


	CDialog::OnInitDialog();


	SetIcon(m_hIcon, TRUE);			// Groes Symbol verwenden
	SetIcon(m_hIcon, FALSE);		// Kleines Symbol verwenden


	if(m_bAutoStart)
		{
		PostMessage(WM_COMMAND,IDOK);
		}

return TRUE;
}


//*****************************************************************************
//*
//*		OnPaint
//*
//*****************************************************************************
// Wollen Sie Ihrem Dialogfeld eine Schaltflche "Minimieren" hinzufgen, bentigen Sie
//  den nachstehenden Code, um das Symbol zu zeichnen. Fr MFC-Anwendungen, die das
//  Dokument/Ansicht-Modell verwenden, wird dies automatisch fr Sie erledigt.
void CShutDownUtilityDlg::OnPaint()
{

	if(IsIconic())
		{
		CPaintDC dc(this); // Gertekontext fr Zeichnen

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Symbol in Client-Rechteck zentrieren
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Symbol zeichnen
		dc.DrawIcon(x, y, m_hIcon);
		}
	else{
		CDialog::OnPaint();
		}
}


//*****************************************************************************
//*
//*		OnQueryDragIcon
//*
//*****************************************************************************
HCURSOR CShutDownUtilityDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

//*****************************************************************************
//*
//*		OnCancel
//*
//*****************************************************************************
void CShutDownUtilityDlg::OnCancel()
{
CRegKeys	sKey;


	sKey.Open(HKEY_CURRENT_USER,"Software\\AZ\\ShutDownUtility");
	sKey.Set(m_sTime,"Time");

	if(m_bHide)
		{
		m_bHide=FALSE;
		TaskbarIconDel(m_hWnd);
		TaskbarShow(m_hWnd);
		ShowWindow(SW_SHOW);
		KillTimer(ID_CHECKTIME);
		}

	CDialog::OnCancel();
}

//*****************************************************************************
//*
//*		OnOK
//*
//*****************************************************************************
void CShutDownUtilityDlg::OnOK()
{
CRegKeys	sKey;


	sKey.Open(HKEY_CURRENT_USER,"Software\\AZ\\ShutDownUtility");
	sKey.Set(m_sTime,"Time");

	UpdateData();
	Start(m_sTime);

}

//*****************************************************************************
//*
//*		Start
//*
//*****************************************************************************
int CShutDownUtilityDlg::Start(const char *pPtr)
{
struct tm  *pData;
char		cText[32];
int			iMinute;
int			iHour;



	if(pPtr[0]<'0' || pPtr[0]>'9')
		{
		MessageBox("Es wurde eine ungltige Zeit eingegeben !","Fehler",MB_OK|MB_ICONERROR);
		return 0;
		}


	iHour = atoi(pPtr);
	pPtr += strchar(pPtr,':');

	if(pPtr[0]!=':' || pPtr[1]<'0' || pPtr[1]>'9')
		{
		MessageBox("Es wurde eine ungltige Zeit eingegeben !","Fehler",MB_OK|MB_ICONERROR);
		return 0;
		}


	iMinute = atoi(pPtr+1);


	if(iMinute<0 || iMinute>59 || iHour<0 || iHour>23)
		{
		MessageBox("Es wurde eine ungltige Zeit eingegeben !","Fehler",MB_OK|MB_ICONERROR);
		return 0;
		}


	sprintf(cText,"Abschaltezeit %02i:%02i",iHour,iMinute);

	TaskbarHide(m_hWnd);
	TaskbarIconAdd(m_hWnd,IDR_MAINFRAME,cText);
	ShowWindow(SW_HIDE);
	m_bHide  = TRUE;
	m_iTime  = time(0);
	m_iTime -= m_iTime%(3600*24);
	m_iTime += iMinute*60;
	m_iTime += iHour*3600;
	m_iTime += _timezone;

	   pData = localtime(&m_iTime);
	if(pData->tm_isdst)
		{
		m_iTime -= 3600;
		}

	if(m_iTime<time(0))m_iTime+=3600*24;
	SetTimer(ID_CHECKTIME,1000*60,NULL);

return 1;
}

//*****************************************************************************
//*
//*		OnIconProc
//*
//*****************************************************************************
void CShutDownUtilityDlg::OnIconProc(UINT wParam,UINT lParam)
{
	if(lParam==WM_LBUTTONDOWN)
		{
		if(m_bHide)
			{
			m_bHide=FALSE;
			TaskbarIconDel(m_hWnd);
			TaskbarShow(m_hWnd);
			ShowWindow(SW_SHOW);
			KillTimer(ID_CHECKTIME);
			}

		SetForegroundWindow();
		}
}




//*****************************************************************************
//*
//*		OnTimer
//*
//*****************************************************************************
void CShutDownUtilityDlg::OnTimer(UINT_PTR nIDEvent)
{

	if(nIDEvent==ID_CHECKTIME)
		{
		LUID				lUid;
		HANDLE				hToken;
		HANDLE				hPrcess;
		TOKEN_PRIVILEGES	sPrivileges;


		if(m_bHide==FALSE )return;
		if(m_iTime>time(0))return;

		hPrcess = GetCurrentProcess();
		OpenProcessToken(hPrcess,TOKEN_ADJUST_PRIVILEGES|TOKEN_QUERY,&hToken);
		LookupPrivilegeValue(NULL,"SeShutdownPrivilege",&lUid);

		sPrivileges.PrivilegeCount				= 1;
		sPrivileges.Privileges[0].Luid			= lUid;
		sPrivileges.Privileges[0].Attributes	= SE_PRIVILEGE_ENABLED;

		AdjustTokenPrivileges(hToken,0,&sPrivileges,sizeof(sPrivileges),NULL,NULL);
		ExitWindowsEx(EWX_SHUTDOWN|EWX_POWEROFF|EWX_FORCEIFHUNG,0);
		OnCancel();
		return;
		}

	CDialog::OnTimer(nIDEvent);
}


//*****************************************************************************
//*
//*		OnShowWindow
//*
//*****************************************************************************
void CShutDownUtilityDlg::OnShowWindow(BOOL bShow, UINT nStatus)
{
	CDialog::OnShowWindow(bShow, nStatus);

	if(!m_bHide && nStatus==SW_SHOW)
		{
		ShowWindow(SW_HIDE);
		}

}
